image: gradle:8-jdk17

include:
  - project: rug-digitallab/resources/gitlab-ci-templates
    ref: develop
    file:
      - gradle/static-analysis/static-analysis.yml
      - gradle/coverage/coverage.yml
      - gradle/test/unit-tests.yml


stages:
  - build
  - test
  - coverage
  - static-analysis

variables:
  # Set the gradle user home to a subdirectory of the build directory,
  # enable the build cache, and print verbose output.
  GRADLE_CLI: "./gradlew --gradle-user-home gradle-home/ --build-cache -i"
  DOCKER_TLS_CERTDIR: "/certs"
  # Flawfinder is erroneously enabled because there is C code in the integration tests
  SAST_EXCLUDED_ANALYZERS: "flawfinder"

cache:
  key:
    files:
      # When the gradle wrapper changes, invalidate cache
      - gradle/wrapper/gradle-wrapper.properties
  paths:
    - gradle-home/wrapper/
    - gradle-home/caches/
    - gradle-home/notifications/

build:
  stage: build
  script:
    - "$GRADLE_CLI companion-container:assemble"
  artifacts:
    paths:
      - companion-container/build/quarkus-app
    expire_in: 1 week
